//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  White
#property indicator_width1  3
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  20
#property indicator_level2  80
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    StartFrom            = 6;
extern int    EndWith              = 48;
extern double Deviations           = 2.0;
extern int    Price                = PRICE_CLOSE; 
extern int    PriceSmoothing       = 5;
extern int    PriceSmoothingMethod = MODE_LWMA;
extern int    BarsToDraw           = 150;
extern int    BarsWidth            = 4;
extern string UniqueID             = "Swami bbosc 2";
extern bool   GenericVisible       = true;
extern color  ColorUp              = LimeGreen;
extern color  ColorDown            = HotPink;

double bbosc[];
double prices[];
double step;
double totalSteps;
int    window;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   int type = DRAW_NONE; if (GenericVisible) type = DRAW_LINE;
   IndicatorBuffers(2);
      SetIndexBuffer(0,bbosc); SetIndexStyle(0,type);
      SetIndexBuffer(1,prices);
      
         //
         //
         //
         //
         //
         
         StartFrom  = MathMax(StartFrom, 6);
         EndWith    = MathMin(EndWith  ,99);
         totalSteps = EndWith-StartFrom+1.0;
         step       = 100.0/(totalSteps-1);
      IndicatorShortName(UniqueID);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i); if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double avgDen[][100];
double avgNum[][100];
double avgSto[][100];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(avgDen,0)!=Bars)
         {
            ArrayResize(avgDen,Bars);
            ArrayResize(avgNum,Bars);
            ArrayResize(avgSto,Bars);
         }            
         window = WindowFind(UniqueID);

         //
         //
         //
         //
         //

         for (i=limit, r=Bars-i-1; i>=0 ; i--,r++) prices[i] = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,Price,i); limit = MathMin(limit,MathMin(BarsToDraw+EndWith,Bars-1));
         for (i=limit, r=Bars-i-1; i>=0 ; i--,r++)
         {
            bbosc[i] = 0;         
            
            //
            //
            //
            //
            //
            
            for (int k=StartFrom; k<EndWith; k++)
            {
               double bbmid = iMA(NULL,0,k,0,MODE_SMA,Price,i);
               double bbdev = Deviations*iStdDev(NULL,0,k,0,MODE_SMA,Price,i);
               double bbpct = 0;
                  if (bbdev>0)
                  {
                     bbpct = MathMin(MathMax((prices[i]-bbmid)/bbdev,-1),1)*50.0+50.0;
                     if (i<BarsToDraw) plot(k,(k-StartFrom)*step,(k-StartFrom+1)*step,i,i,gradientColor(bbpct,101,ColorDown,ColorUp),BarsWidth);
                  }
               bbosc[i] += bbpct;
            }               
            bbosc[i] /= totalSteps;
         }
         
   //
   //
   //
   //
   //

   SetIndexDrawBegin(0,Bars-BarsToDraw);
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void plot(string namex,double valueA, double valueB, int shiftA, int shiftB, color theColor, int width=0,int style=STYLE_SOLID)
{
   string   name = UniqueID+":"+namex+Time[shiftA];
   
   //
   //
   //
   //
   //
   
   if (ObjectFind(name) == -1) 
   {
       ObjectCreate(name,OBJ_TREND,window,Time[shiftA],valueA,Time[shiftB],valueB);
          ObjectSet(name,OBJPROP_RAY,false);
          ObjectSet(name,OBJPROP_BACK,true);
          ObjectSet(name,OBJPROP_STYLE,style);
          ObjectSet(name,OBJPROP_WIDTH,width);
   }
   ObjectSet(name,OBJPROP_COLOR,theColor);
   ObjectSet(name,OBJPROP_PRICE1,valueA);
   ObjectSet(name,OBJPROP_PRICE2,valueB);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

color gradientColor(int tstep, int ttotalSteps, color from, color to)
{
   color newBlue  = getColor(tstep,ttotalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(tstep,ttotalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(tstep,ttotalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int ttotalSteps, color from, color to)
{
   double tstep = (from-to)/(ttotalSteps-1.0);
   return(MathRound(from-tstep*stepNo));
}